"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HighlightEditor = void 0;

var React = _interopRequireWildcard(require("react"));

var _renderer = require("./renderer");

var _editorUi = require("@edtr-io/editor-ui");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Textarea = _editorUi.styled.textarea({
  height: '250px',
  width: '100%',
  margin: 'auto',
  padding: '10px',
  resize: 'none',
  fontFamily: 'Menlo, Monaco, "Courier New", monospace',
  border: 'none',
  outline: 'none',
  boxShadow: '0 1px 1px 0 rgba(0,0,0,0.50)',
  '&::-webkit-input-placeholder': {
    color: 'rgba(0,0,0,0.5)'
  }
});

var QuestionIcon = (0, _editorUi.styled)(_editorUi.Icon)({
  color: 'black',
  margin: '0 10px -3px 5px',
  '&:hover': {
    color: 'rgba(0,0,0,0.5)'
  }
});

var CheckboxContainer = _editorUi.styled.div({
  float: 'right'
}); //TODO: type and theming. maybe put in editor-ui?


var HelpIcon = function HelpIcon() {
  return React.createElement("a", {
    href: "https://github.com/conorhastings/react-syntax-highlighter/blob/master/AVAILABLE_LANGUAGES_HLJS.MD",
    rel: "noopener noreferrer",
    target: "_blank",
    title: "Available Languages"
  }, React.createElement(QuestionIcon, {
    icon: _editorUi.faQuestionCircle
  }));
};

var HighlightEditor = function HighlightEditor(props) {
  var state = props.state,
      focused = props.focused,
      editable = props.editable;
  var edit = focused && editable;

  var _React$useState = React.useState(edit),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      throttledEdit = _React$useState2[0],
      setEditThrotteled = _React$useState2[1];

  if (edit != throttledEdit) {
    if (!edit) {
      setTimeout(function () {
        setEditThrotteled(false);
      }, 500);
    } else {
      setEditThrotteled(true);
    }
  }

  return throttledEdit || edit ? React.createElement(React.Fragment, null, React.createElement(Textarea, {
    value: state.text.value,
    name: "text",
    placeholder: "Write some code here. Preview will be shown when you leave the area",
    onChange: function onChange(e) {
      state.text.set(e.target.value);
    }
  }, state.text.value), React.createElement(_editorUi.EditorInput, {
    label: "Language:",
    value: state.language.value,
    onChange: function onChange(e) {
      state.language.set(e.target.value);
    },
    placeholder: "enter Language"
  }), React.createElement(HelpIcon, null), React.createElement(CheckboxContainer, null, React.createElement(_editorUi.EditorCheckbox, {
    label: "Show Line Numbers",
    onChange: function onChange() {
      state.lineNumbers.set(!state.lineNumbers.value);
    },
    checked: state.lineNumbers.value
  }))) : React.createElement(_renderer.HighlightRenderer, props);
};

exports.HighlightEditor = HighlightEditor;
//# sourceMappingURL=editor.js.map